/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the PropertyDescription type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PropertyDescription{}

// PropertyDescription struct for PropertyDescription
type PropertyDescription struct {
	PropertyName      NullableString `json:"propertyName,omitempty"`
	PropertyType      *PropertyType  `json:"propertyType,omitempty"`
	Description       NullableString `json:"description,omitempty"`
	DisplayOrder      *int32         `json:"displayOrder,omitempty"`
	IsIdentifier      *bool          `json:"isIdentifier,omitempty"`
	Required          *bool          `json:"required,omitempty"`
	ValidationPattern NullableString `json:"validationPattern,omitempty"`
	Multivalued       *bool          `json:"multivalued,omitempty"`
	ReadOnly          *bool          `json:"readOnly,omitempty"`
}

// NewPropertyDescription instantiates a new PropertyDescription object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPropertyDescription() *PropertyDescription {
	this := PropertyDescription{}
	return &this
}

// NewPropertyDescriptionWithDefaults instantiates a new PropertyDescription object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPropertyDescriptionWithDefaults() *PropertyDescription {
	this := PropertyDescription{}
	return &this
}

// GetPropertyName returns the PropertyName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PropertyDescription) GetPropertyName() string {
	if o == nil || IsNil(o.PropertyName.Get()) {
		var ret string
		return ret
	}
	return *o.PropertyName.Get()
}

// GetPropertyNameOk returns a tuple with the PropertyName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PropertyDescription) GetPropertyNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PropertyName.Get(), o.PropertyName.IsSet()
}

// HasPropertyName returns a boolean if a field has been set.
func (o *PropertyDescription) HasPropertyName() bool {
	if o != nil && o.PropertyName.IsSet() {
		return true
	}

	return false
}

// SetPropertyName gets a reference to the given NullableString and assigns it to the PropertyName field.
func (o *PropertyDescription) SetPropertyName(v string) {
	o.PropertyName.Set(&v)
}

// SetPropertyNameNil sets the value for PropertyName to be an explicit nil
func (o *PropertyDescription) SetPropertyNameNil() {
	o.PropertyName.Set(nil)
}

// UnsetPropertyName ensures that no value is present for PropertyName, not even an explicit nil
func (o *PropertyDescription) UnsetPropertyName() {
	o.PropertyName.Unset()
}

// GetPropertyType returns the PropertyType field value if set, zero value otherwise.
func (o *PropertyDescription) GetPropertyType() PropertyType {
	if o == nil || IsNil(o.PropertyType) {
		var ret PropertyType
		return ret
	}
	return *o.PropertyType
}

// GetPropertyTypeOk returns a tuple with the PropertyType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PropertyDescription) GetPropertyTypeOk() (*PropertyType, bool) {
	if o == nil || IsNil(o.PropertyType) {
		return nil, false
	}
	return o.PropertyType, true
}

// HasPropertyType returns a boolean if a field has been set.
func (o *PropertyDescription) HasPropertyType() bool {
	if o != nil && !IsNil(o.PropertyType) {
		return true
	}

	return false
}

// SetPropertyType gets a reference to the given PropertyType and assigns it to the PropertyType field.
func (o *PropertyDescription) SetPropertyType(v PropertyType) {
	o.PropertyType = &v
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PropertyDescription) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PropertyDescription) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *PropertyDescription) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *PropertyDescription) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *PropertyDescription) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *PropertyDescription) UnsetDescription() {
	o.Description.Unset()
}

// GetDisplayOrder returns the DisplayOrder field value if set, zero value otherwise.
func (o *PropertyDescription) GetDisplayOrder() int32 {
	if o == nil || IsNil(o.DisplayOrder) {
		var ret int32
		return ret
	}
	return *o.DisplayOrder
}

// GetDisplayOrderOk returns a tuple with the DisplayOrder field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PropertyDescription) GetDisplayOrderOk() (*int32, bool) {
	if o == nil || IsNil(o.DisplayOrder) {
		return nil, false
	}
	return o.DisplayOrder, true
}

// HasDisplayOrder returns a boolean if a field has been set.
func (o *PropertyDescription) HasDisplayOrder() bool {
	if o != nil && !IsNil(o.DisplayOrder) {
		return true
	}

	return false
}

// SetDisplayOrder gets a reference to the given int32 and assigns it to the DisplayOrder field.
func (o *PropertyDescription) SetDisplayOrder(v int32) {
	o.DisplayOrder = &v
}

// GetIsIdentifier returns the IsIdentifier field value if set, zero value otherwise.
func (o *PropertyDescription) GetIsIdentifier() bool {
	if o == nil || IsNil(o.IsIdentifier) {
		var ret bool
		return ret
	}
	return *o.IsIdentifier
}

// GetIsIdentifierOk returns a tuple with the IsIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PropertyDescription) GetIsIdentifierOk() (*bool, bool) {
	if o == nil || IsNil(o.IsIdentifier) {
		return nil, false
	}
	return o.IsIdentifier, true
}

// HasIsIdentifier returns a boolean if a field has been set.
func (o *PropertyDescription) HasIsIdentifier() bool {
	if o != nil && !IsNil(o.IsIdentifier) {
		return true
	}

	return false
}

// SetIsIdentifier gets a reference to the given bool and assigns it to the IsIdentifier field.
func (o *PropertyDescription) SetIsIdentifier(v bool) {
	o.IsIdentifier = &v
}

// GetRequired returns the Required field value if set, zero value otherwise.
func (o *PropertyDescription) GetRequired() bool {
	if o == nil || IsNil(o.Required) {
		var ret bool
		return ret
	}
	return *o.Required
}

// GetRequiredOk returns a tuple with the Required field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PropertyDescription) GetRequiredOk() (*bool, bool) {
	if o == nil || IsNil(o.Required) {
		return nil, false
	}
	return o.Required, true
}

// HasRequired returns a boolean if a field has been set.
func (o *PropertyDescription) HasRequired() bool {
	if o != nil && !IsNil(o.Required) {
		return true
	}

	return false
}

// SetRequired gets a reference to the given bool and assigns it to the Required field.
func (o *PropertyDescription) SetRequired(v bool) {
	o.Required = &v
}

// GetValidationPattern returns the ValidationPattern field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *PropertyDescription) GetValidationPattern() string {
	if o == nil || IsNil(o.ValidationPattern.Get()) {
		var ret string
		return ret
	}
	return *o.ValidationPattern.Get()
}

// GetValidationPatternOk returns a tuple with the ValidationPattern field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *PropertyDescription) GetValidationPatternOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ValidationPattern.Get(), o.ValidationPattern.IsSet()
}

// HasValidationPattern returns a boolean if a field has been set.
func (o *PropertyDescription) HasValidationPattern() bool {
	if o != nil && o.ValidationPattern.IsSet() {
		return true
	}

	return false
}

// SetValidationPattern gets a reference to the given NullableString and assigns it to the ValidationPattern field.
func (o *PropertyDescription) SetValidationPattern(v string) {
	o.ValidationPattern.Set(&v)
}

// SetValidationPatternNil sets the value for ValidationPattern to be an explicit nil
func (o *PropertyDescription) SetValidationPatternNil() {
	o.ValidationPattern.Set(nil)
}

// UnsetValidationPattern ensures that no value is present for ValidationPattern, not even an explicit nil
func (o *PropertyDescription) UnsetValidationPattern() {
	o.ValidationPattern.Unset()
}

// GetMultivalued returns the Multivalued field value if set, zero value otherwise.
func (o *PropertyDescription) GetMultivalued() bool {
	if o == nil || IsNil(o.Multivalued) {
		var ret bool
		return ret
	}
	return *o.Multivalued
}

// GetMultivaluedOk returns a tuple with the Multivalued field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PropertyDescription) GetMultivaluedOk() (*bool, bool) {
	if o == nil || IsNil(o.Multivalued) {
		return nil, false
	}
	return o.Multivalued, true
}

// HasMultivalued returns a boolean if a field has been set.
func (o *PropertyDescription) HasMultivalued() bool {
	if o != nil && !IsNil(o.Multivalued) {
		return true
	}

	return false
}

// SetMultivalued gets a reference to the given bool and assigns it to the Multivalued field.
func (o *PropertyDescription) SetMultivalued(v bool) {
	o.Multivalued = &v
}

// GetReadOnly returns the ReadOnly field value if set, zero value otherwise.
func (o *PropertyDescription) GetReadOnly() bool {
	if o == nil || IsNil(o.ReadOnly) {
		var ret bool
		return ret
	}
	return *o.ReadOnly
}

// GetReadOnlyOk returns a tuple with the ReadOnly field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PropertyDescription) GetReadOnlyOk() (*bool, bool) {
	if o == nil || IsNil(o.ReadOnly) {
		return nil, false
	}
	return o.ReadOnly, true
}

// HasReadOnly returns a boolean if a field has been set.
func (o *PropertyDescription) HasReadOnly() bool {
	if o != nil && !IsNil(o.ReadOnly) {
		return true
	}

	return false
}

// SetReadOnly gets a reference to the given bool and assigns it to the ReadOnly field.
func (o *PropertyDescription) SetReadOnly(v bool) {
	o.ReadOnly = &v
}

func (o PropertyDescription) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PropertyDescription) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.PropertyName.IsSet() {
		toSerialize["propertyName"] = o.PropertyName.Get()
	}
	if !IsNil(o.PropertyType) {
		toSerialize["propertyType"] = o.PropertyType
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if !IsNil(o.DisplayOrder) {
		toSerialize["displayOrder"] = o.DisplayOrder
	}
	if !IsNil(o.IsIdentifier) {
		toSerialize["isIdentifier"] = o.IsIdentifier
	}
	if !IsNil(o.Required) {
		toSerialize["required"] = o.Required
	}
	if o.ValidationPattern.IsSet() {
		toSerialize["validationPattern"] = o.ValidationPattern.Get()
	}
	if !IsNil(o.Multivalued) {
		toSerialize["multivalued"] = o.Multivalued
	}
	if !IsNil(o.ReadOnly) {
		toSerialize["readOnly"] = o.ReadOnly
	}
	return toSerialize, nil
}

type NullablePropertyDescription struct {
	value *PropertyDescription
	isSet bool
}

func (v NullablePropertyDescription) Get() *PropertyDescription {
	return v.value
}

func (v *NullablePropertyDescription) Set(val *PropertyDescription) {
	v.value = val
	v.isSet = true
}

func (v NullablePropertyDescription) IsSet() bool {
	return v.isSet
}

func (v *NullablePropertyDescription) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePropertyDescription(val *PropertyDescription) *NullablePropertyDescription {
	return &NullablePropertyDescription{value: val, isSet: true}
}

func (v NullablePropertyDescription) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePropertyDescription) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
